<?php

/**
 * co_consulta_campos actions.
 *
 * @package    contratacion
 * @subpackage co_consulta_campos
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_consulta_camposActions extends sfActions
{
 /**
  * Executes index action
  *
  * @param sfRequest $request A request object
  */
  public function executeList(sfWebRequest $request)
  {
    //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejar Errores
         */
        try {

            /*
             * Variables para el registro de log
             */

            //1 - indica operacion de consulta
            $id_ope_bd = 1;

            //obtener id maestro tabla
            $id_mae_bd = CN_TABLE::consultarIdTablaBD('co_estudios_previos');


            //CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, $observacion);
            
            /*
             * Filtro para que levante por CO_ESTUDIOS_PREVIOS y por FASE
             */
            if(isset($request['id_estudios_previos'])&&isset($request['id_fase_ep'])){
                $whereEstudiosFase="AND tab0.id_estudios_previos='".$request['id_estudios_previos']."' AND tab2.campo_ep.fase_ep.id_fase_ep='".$request['id_fase_ep']."'";
            }
            /*
             * Obtiene las vigencias/periodo que se encuentre en la tabla de saldos
             */
            $sql = <<<EOD
SELECT *
                    
from(
                 
select 
tab2.campo_ep.id_campo_ep as id_campo_ep,
tab2.campo_ep.codigo as codigo,
case when tab8.id_campo_obliga is null then tab2.campo_ep.descripcion||' ' when tab8.obligatorio = 0 then tab2.campo_ep.descripcion||' ' else tab2.campo_ep.descripcion||' '||'(Obligatorio)' end AS descripcion,                     
tab2.campo_ep.estado as estado,
tab2.campo_ep.tipo_campo as tipo_campo,
tab2.campo_ep.tamano_campo as tamano_campo,
tab2.campo_ep.obligatorio as obligatorio,
tab2.campo_ep.aplica_relacion as aplica_relacion,
tab2.campo_ep.tipo_captura.descripcion as descripcion_captura,
tab2.campo_ep.tabla_cc.cc as nombre_cc,
tab2.campo_ep.tabla_cc.tabla as tabla_cc,
case when tab7.valor is null then tab2.default_value else tab7.valor end as valor,  
tab7.id_detalle_ep,
tab2.orden,
tab7.comentario as comentario
from co_estudios_previos tab0
join co_modalidad_sel tab1 on tab0.id_modalidad_sel=tab1.id_modalidad_sel
left join co_campo_modalidad tab2 on tab1.id_modalidad_sel=tab2.id_modalidad_sel
left join co_detalle_ep tab7 on tab0.id_estudios_previos=tab7.id_estudios_previos and tab2.campo_ep.id_campo_ep=tab7.id_campo_ep
left join co_campo_obliga tab8 ON tab8.id_modalidad_sel = tab0.id_modalidad_sel and tab8.id_campo_ep = tab2.campo_ep.id_campo_ep    
   where
1=1  
$whereEstudiosFase

                    
union all 
    
select 
tab2.campo_ep.id_campo_ep as id_campo_ep,
tab2.campo_ep.codigo as codigo,
case when tab8.id_campo_obliga is null then tab2.campo_ep.descripcion||' ' when tab8.obligatorio = 0 then tab2.campo_ep.descripcion||' ' else tab2.campo_ep.descripcion||' '||'(Obligatorio)' end AS descripcion,                     
tab2.campo_ep.estado as estado,
tab2.campo_ep.tipo_campo as tipo_campo,
tab2.campo_ep.tamano_campo as tamano_campo,
tab2.campo_ep.obligatorio as obligatorio,
tab2.campo_ep.aplica_relacion as aplica_relacion,
'DescargarItem' as descripcion_captura,
tab2.campo_ep.tabla_cc.cc as nombre_cc,
tab2.campo_ep.tabla_cc.tabla as tabla_cc,
case when tab7.valor is null then tab2.default_value else tab7.valor end as valor,  
tab7.id_detalle_ep,
tab2.orden,
tab7.comentario as comentario
from co_estudios_previos tab0
join co_modalidad_sel tab1 on tab0.id_modalidad_sel=tab1.id_modalidad_sel
left join co_campo_modalidad tab2 on tab1.id_modalidad_sel=tab2.id_modalidad_sel
left join co_detalle_ep tab7 on tab0.id_estudios_previos=tab7.id_estudios_previos and tab2.campo_ep.id_campo_ep=tab7.id_campo_ep
left join co_campo_obliga tab8 ON tab8.id_modalidad_sel = tab0.id_modalidad_sel and tab8.id_campo_ep = tab2.campo_ep.id_campo_ep
where

tab2.campo_ep.tipo_captura.descripcion='ArchivoItem' and tab7.valor is not null 
$whereEstudiosFase
)order by orden,descripcion_captura
                    
                    
EOD;
            $records = CN_TABLE::executeSQL($sql);

            //Ejecuta sql
            $this->totalRows = count($records);
            $this->list_data = $records;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
  }
}
